
public class Context {
  boolean bFlag;
  boolean emFlag;
  boolean iFlag;
  boolean sFlag;
  boolean ttFlag;
  int u;
  int size;
  int color;

  static int UNDEFINED = 999;
public Context(Context other) {
    this.bFlag = other.bFlag;
    this.emFlag = other.emFlag;
    this.iFlag = other.iFlag;
    this.sFlag = other.sFlag;
    this.ttFlag = other.ttFlag;
    this.u = other.u;
    this.size = other.size;
    this.color = other.color;
  }

  public boolean equals(Context other) {
    if (this.bFlag == other.bFlag && this.emFlag == other.emFlag
         && this.iFlag == other.iFlag && this.sFlag == other.sFlag
         && this.ttFlag == other.ttFlag &&  this.u == other.u
         && this.size == other.size && this.color == other.color) {
      return(true);
    } else {
      return(false);
    }
  }

  public Context() {
    bFlag = emFlag = iFlag = sFlag = ttFlag = false;
    u = 0;
    size = UNDEFINED;
    color = UNDEFINED;
  }

  public void setTag(char tag) {
    if (tag == Main.BOLD) {
      bFlag = true;
    } else if (tag == Main.EM) {
      if (!sFlag) {
        emFlag = !emFlag;
      }
    } else if (tag == Main.ITALIC) {
      iFlag = true;
    } else if (tag == Main.PLAIN) {
      u = 0; sFlag = emFlag = iFlag = bFlag = ttFlag = false;
    } else if (tag == Main.STRONG) {
      sFlag = true; 
      emFlag = false;
    } else if (tag == Main.TYPEWRITER) {
      ttFlag = true;
    } else if (tag == Main.UNDERLINE) {
      if (u < 3) { 
        u++; 
      }
    } else if (tag >= Main.ZERO && tag <= Main.NINE) {
      size = tag - Main.ZERO;
    } else if (tag >= Main.RED && tag <= Main.WHITE) {
      color = tag;
    }
  }

  public String toString() {
    String ret = "";
    if (bFlag) {
      ret += "b;";
    }
    if (ttFlag) {
      ret += "tt;";
    }
    if (sFlag) {
      ret += "s;";
    }
    if (iFlag) {
      ret += "i;";
    }
    if (emFlag) {
      ret += "em;";
    }
    ret += "C:" + color + " S:" + size + " U: " + u;
    return(ret);
  }

  public boolean getTTFlag() {
    return(ttFlag);
  }

  public boolean getSFlag() {
    return(sFlag);
  }

}
